// List of variables localized from wpe-tools :
// ajaxurl, initialPrice, currency, emailUrl, email_subject, admin_email, colorA, colorB, intro_enabled, save_to_cart, close_url

var step = 0;
var price = 0;
var priceMax = 0;
var timer_gFormSubmit = null;
var timer_gFormDesign = null;
var gFormDesignCheck = 0;

jQuery(document).ready(function() {
    initialPrice = parseFloat(initialPrice);
    if (save_to_cart == 1) {
        save_to_cart = true;
    } else {
        save_to_cart = false;
    }
    disablesThemeStyles();
    disablesThemeScripts();
    jQuery('body').hide();
    jQuery('body').html(jQuery('#estimation_popup').html());
    jQuery('body').attr('class', '');
    jQuery('body').delay(500).fadeIn(500);
    initPrice();
    updatePrice();
    jQuery('#btnStart').click(openGenerator);
    initFlatUI();
    jQuery('#mainPanel .genSlide div.selectable.prechecked,#mainPanel .genSlide input[type=checkbox][data-price].prechecked').each(function() {
        itemClick(jQuery(this));
    });
    jQuery('select').addClass('select-block').selectpicker({style: 'btn-primary', menuStyle: 'dropdown-inverse'});
    if (intro_enabled == '0') {
        jQuery('#btnStart').hide();
        jQuery('.genPrice').fadeIn(500);
        jQuery('#mainPanel').fadeIn(500, function() {
            nextStep();
        });
    }
    initGform();
});
jQuery(window).load(function() {
    checkItems();
    initListeners();
});

function initGform() {
    gFormDesignCheck++;
    if (timer_gFormDesign) {
        jQuery('#finalSlide').delay(100).animate({
            opacity: 1
        }, 1000);
    }
    jQuery('select').addClass('select-block').selectpicker({style: 'btn-primary', menuStyle: 'dropdown-inverse'});
    jQuery('input[type=radio]').not('[data-toggle="radio"]').attr('data-toggle', 'radio');
    jQuery('.ginput_container input, .ginput_container select, .ginput_container textarea').attr('title', 'control');
    jQuery('.ginput_container input, .ginput_container textarea').not('[type=checkbox]').not('[type=radio]').not('[type=submit]').addClass('form-control');
    jQuery('.ginput_container').addClass('form-group');
    jQuery('.gform_button').attr('class', 'btn btn-wide btn-primary');
    jQuery('#finalSlide .gform_wrapper input[type="radio"]:not(.ready)').each(function() {
        jQuery(this).addClass('ready');
        var label = jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').html();
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').css('display', 'inline-block');
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').append(jQuery(this));
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').addClass('radio');
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').prepend('<span class="icons"><span class="first-icon fui-radio-unchecked"></span><span class="second-icon fui-radio-checked"></span></span>');

        if (!jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').next().is('br')) {
            jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').after('<br/>');
        }
        if (jQuery(this).is(':checked')) {
            jQuery(this).trigger('click');
        }
    });
    jQuery('#finalSlide .gform_wrapper input[type="checkbox"]:not(.ready)').each(function() {
        jQuery(this).addClass('ready');
        var label = jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').html();
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').css('display', 'inline-block');
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').append(jQuery(this));
        jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').addClass('checkbox');
        jQuery(this).before('<span class="icons"><span class="first-icon fui-checkbox-unchecked"></span><span class="second-icon fui-checkbox-checked"></span></span>');
        if (!jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').next().is('br')) {
            jQuery('#finalSlide .gform_wrapper label[for="' + jQuery(this).attr('id') + '"]').parent('li').after('<br/>');
        }

    });
    jQuery('#finalSlide .gform_wrapper label.checkbox').each(function() {
        if (jQuery(this).find('[type=checkbox]').length > 0) {
            jQuery(this).find('[type=checkbox]').eq(1).remove();
        }
        if (jQuery(this).find('[type=checkbox]').is(':checked')) {
            jQuery(this).find('[type=checkbox]').trigger('click');
        }
    });

    jQuery('#finalSlide .gform_wrapper form [type="submit"]').click(function(e) {
       
            e.preventDefault();
            jQuery(this).addClass('anim');
            gFormDesignCheck = 0;
            jQuery('#finalSlide').delay(1000).animate({
                opacity: 0
            }, 1000);
            var $this = jQuery(this);
            setTimeout(function(){
                jQuery('#finalSlide .gform_wrapper form').submit();
                timer_gFormDesign = setTimeout(initGform, 2000);
            }, 1000);
        
    });
}

function checkItems() {
    jQuery('#mainPanel .genSlide div.selectable img[data-tint="true"]').each(function() {
        jQuery(this).css('opacity', 0);
        jQuery(this).show();
        var $canvas = jQuery('<canvas class="img"></canvas>');
        $canvas.css({
            width: jQuery(this).get(0).width,
            height: jQuery(this).get(0).height
        });
        jQuery(this).hide();
        jQuery(this).after($canvas);
        var ctx = $canvas.get(0).getContext('2d');
        var img = new Image();
        img.onload = function() {
            ctx.fillStyle = colorA;
            ctx.fillRect(0, 0, $canvas.get(0).width, $canvas.get(0).height);
            ctx.fill();
            ctx.globalCompositeOperation = 'destination-in';
            ctx.drawImage(img, 0, 0, $canvas.get(0).width, $canvas.get(0).height);
        };
        img.src = jQuery(this).attr('src');
    });
}

function initFlatUI() {
    jQuery(".tagsinput").tagsInput();
    jQuery(":text, textarea").placeholder();
    jQuery('.input-group').on('focus', '.form-control', function() {
        jQuery(this).closest('.input-group, .form-group').addClass('focus');
    }).on('blur', '.form-control', function() {
        jQuery(this).closest('.input-group, .form-group').removeClass('focus');
    });
    jQuery(".pagination").on('click', "a", function() {
        jQuery(this).parent().siblings("li").removeClass("active").end().addClass("active");
    });
    jQuery(".btn-group").on('click', "a", function() {
        jQuery(this).siblings().removeClass("active").end().addClass("active");
    });
    jQuery(document).on('click', 'a[href="#fakelink"]', function(e) {
        e.preventDefault();
    });
    jQuery("[data-toggle='switch']").wrap('<div class="switch" />').parent().bootstrapSwitch();

    window.prettyPrint && prettyPrint();
}

function disablesThemeStyles() {
    jQuery('link').each(function() {
        if ((jQuery(this).attr("id") != "wpe-colors-css") && (jQuery(this).attr("id") != "wpe-flat-ui-css") && (jQuery(this).attr("id") != "wpe-frontend-css") && (jQuery(this).attr("id") != "wpe-bootstrap-css") && (jQuery(this).attr("id") != "wpe-estimationpopup-css") && (jQuery(this).attr("id") != "wpe-colors-css")) {
            jQuery(this).attr("disabled", "disabled");
        }

    });
}

function disablesThemeScripts() {
    var scriptsCheck = false;
    jQuery('script').each(function() {
        if ((scriptsCheck) && (jQuery(this).attr('src') || jQuery(this).parent().get(0).tagname == 'HEAD')) {
            jQuery(this).attr("disabled", "disabled");
        }
        if (jQuery(this).attr("src") && jQuery(this).attr("src").indexOf("estimation_popup") > 0) {
            scriptsCheck = true;
        }

    });
}

function initPrice() {
    jQuery('#mainPanel .genSlide [data-price]').each(function() {
        if (jQuery(this).data('price') && jQuery(this).data('price') > 0) {
            if (jQuery(this).find('.icon_quantity').length > 0) {
                var max = parseInt(jQuery(this).find('.icon_quantity').html());
                if (max > 10 && parseFloat(jQuery(this).data('price')) > 100) {
                    max = 10;
                } else if (max > 30) {
                    max = 30;
                } else {
                    max = parseInt(jQuery(this).find('.quantityBtns').data('max'));
                }
                priceMax += parseFloat(jQuery(this).data('price')) * max;
            } else {
                priceMax += parseFloat(jQuery(this).data('price'));
            }
        }
    });
    priceMax += initialPrice;
}

function itemClick($item, action) {
    var chkGrpReq = false;
    var $this = $item;

    if (action) {
        jQuery('.quantityBtns').removeClass('open');
        jQuery('.quantityBtns').fadeOut(250);
    }

    if (action) {
        $this.addClass('action');
    }
    if ((action) || (!$this.is('.action'))) {
        $this.find('span.icon_select').animate({
            bottom: 160,
            opacity: 0
        }, 200);
        if ($this.is('.checked')) {
            if ((action) && ($this.data('required'))) {
            } else {
                $this.delay(220).removeClass('checked');
                $this.delay(220).find('span.icon_select').removeClass('fui-check').addClass('fui-cross');
            }
            $this.find('.icon_quantity').delay(300).fadeOut(200);

        } else {
            $this.delay(220).addClass('checked');
            $this.delay(220).find('span.icon_select').removeClass('fui-cross').addClass('fui-check');
            if ($this.find('.icon_quantity').length > 0) {
                $this.find('.icon_quantity').delay(300).fadeIn(200);
                $this.find('.quantityBtns').delay(500).addClass('open');
                $this.find('.quantityBtns').delay(500).fadeIn('200');
            }
        }
        $this.find('span.icon_select').delay(300).animate({
            bottom: 0,
            opacity: 1
        }, 200);

        if ((action) && ($this.data('group'))) {
            jQuery('#mainPanel .genSlide div.selectable.checked[data-group="' + $this.data('group') + '"]').each(function() {
                itemClick(jQuery(this));
            });
        }

        setTimeout(function() {
            updatePrice();
            $this.removeClass('action');
        }, 220);
    }
}

function initListeners() {
    jQuery('#mainPanel .genSlide div.selectable .img, #mainPanel .genSlide div.selectable .icon_select').click(function() {
        itemClick(jQuery(this).parent(), true);
    });
    jQuery('#mainPanel input[type=checkbox][data-price]').change(function() {
        updatePrice();
    });
    jQuery('#mainPanel .genSlide input[type=text][data-title]').change(function() {
        if (jQuery(this).val().length > 0) {
            jQuery(this).addClass('checked');
        }
    });
    jQuery('#mainPanel .genSlide div.selectable .icon_quantity').click(function() {
        jQuery('.quantityBtns').not(jQuery(this).parent().find('.quantityBtns')).removeClass('open');
        jQuery('.quantityBtns').not(jQuery(this).parent().find('.quantityBtns')).fadeOut(250);

        if (!jQuery(this).parent().find('.quantityBtns').is('.open') && jQuery(this).parent().is('.checked')) {
            jQuery(this).parent().find('.quantityBtns').addClass('open');
            jQuery(this).parent().find('.quantityBtns').fadeIn(250);
        } else {
            jQuery(this).parent().find('.quantityBtns').removeClass('open');
            jQuery(this).parent().find('.quantityBtns').fadeOut(250);
        }
    });

    jQuery('#orderMessageCheck').change(function() {
        if (jQuery(this).is(':checked')) {
            jQuery('#orderMessage').slideDown(250);
        } else {
            jQuery('#orderMessage').slideUp(250);
        }
    });
    jQuery('#btnOrder').click(order);

    jQuery('#finalSlide .gform_wrapper form').submit(function(e) {
        var $this = jQuery(this);
        if (!jQuery(this).is('.submit')) {
            e.preventDefault();
            jQuery(this).addClass('submit');
            timer_gFormSubmit = setInterval(check_gform_response, 300);
            setTimeout(function() {
                $this.submit();
            }, 700);
        } else {
            jQuery(this).removeClass('submit');
        }
    });



}

function check_gform_response() {
    if (jQuery('#gforms_confirmation_message').length > 0) {
        clearInterval(timer_gFormSubmit);
        jQuery('#finalText').html(jQuery('#gforms_confirmation_message').html());
        finalStep();
    }
}

function quantity_less(btn) {
    var $target = jQuery(btn).parent().parent().find('.icon_quantity');
    var quantity = parseInt($target.html());
    if (quantity > 1) {
        quantity--;
        $target.html(quantity);
        updatePrice();
    }
}

function quantity_more(btn) {
    var $target = jQuery(btn).parent().parent().find('.icon_quantity');
    var max = parseInt(jQuery(btn).parent().data('max'));
    var quantity = parseInt($target.html());
    if (quantity < max || max == 0) {
        quantity++;
        $target.html(quantity);
        updatePrice();
    }
}

function checkEmail(email) {
    if (email.indexOf("@") != "-1" && email.indexOf(".") != "-1" && email != "")
        return true;
    return false;
}

function isIframe() {
    try {
        return window.self !== window.top;
    } catch (e) {
        return true;
    }
}

function closePopup() {
    if (isIframe()) {
        window.parent.close_popup_estimation();
        setTimeout(function() {
            document.location.href = document.location.href;
        }, 1000);
    } else {
        if (close_url != "" && close_url != "#" && close_url != " ") {
            document.location.href = close_url;
        } else {
            window.location.href = document.referrer;
        }
    }
}

function getFormContent() {
    var content = "";
    var contentGform = "";
    var totalTxt = "";
    var items = new Array();
    jQuery('#mainPanel .genSlide[data-title]').each(function() {
        $panel = jQuery(this);
        content += "<br/><br/><p><u><b>" + $panel.data("title") + " :</b></u></p>";
        $panel.find('div.selectable.checked').each(function() {
            var quantityText = '';
            var quantity = 1;
            var priceItem = 0;
            if (jQuery(this).data('price')) {
                priceItem = jQuery(this).data('price');
                var price = jQuery(this).data('price') + currency;
                if (jQuery(this).find('.icon_quantity').length > 0) {
                    quantity = jQuery(this).find('.icon_quantity').html();
                    quantityText = quantity + 'X ';
                    price = parseInt(jQuery(this).find('.icon_quantity').html()) * parseFloat(jQuery(this).data('price'));
                    price += currency;
                }

                content += '    - ' + quantityText + jQuery(this).data("title") + ' : ' + price + '<br/>';
                contentGform += ' - ' + quantityText + jQuery(this).data("title") + ' : ' + price + '\n';
            } else {
                content += '    - ' + quantityText + jQuery(this).data("title") + '<br/>';
                contentGform += ' - ' + quantityText + jQuery(this).data("title") + '\n';
            }
            items.push({
                label: jQuery('label[for="' + jQuery(this).attr('id') + '"]').html(),
                price: priceItem,
                quantity: quantity
            });
        });
        $panel.find('input[type=checkbox]:checked').each(function() {
            var priceItem = 0;
            if (jQuery(this).data('price')) {
                priceItem = jQuery(this).data('price');
                content += '    - ' + jQuery(this).data("title") + ' :' + jQuery(this).data('price') + currency + '<br/>';
                contentGform += ' - ' + jQuery(this).data("title") + ' :' + jQuery(this).data('price') + currency + '\n';
            } else {
                content += '    - ' + jQuery(this).data("title") + '<br/>';
                contentGform += ' - ' + jQuery(this).data("title") + '\n';
            }
            items.push({
                label: jQuery(this).data("title"),
                price: priceItem,
                quantity: 1
            });
        });
        $panel.find('input[type=text].checked').each(function() {
            content += '    - ' + jQuery(this).data("title") + ' : <b>' + jQuery(this).val() + '</b><br/>';
            contentGform += ' - ' + jQuery(this).data("title") + ' : ' + jQuery(this).val() + ' \n';
            items.push({
                label: jQuery(this).data("title"),
                value: jQuery(this).val()
            });
        });


    });
    totalTxt += '<br/><hr/><br/><h1>Total : <b>' + price + currency + '</b></h1>';
    contentGform += '\n\nTotal : ' + price + currency;

    return new Array(content, totalTxt, items, contentGform);
}

function order() {
    if (!save_to_cart) {
        var error = false;
        var informations = '';
        var email = '';

        var fields = new Array();


        jQuery('#finalSlide .form-group').removeClass('has-error');
        jQuery('#finalSlide input[type=text],#finalSlide input[type=email], #finalSlide textarea').each(function() {
            if (jQuery(this).data('required') == 'true' && jQuery(this).val().length < 1) {
                error = true;
                jQuery(this).parent().addClass('has-error');
            }
            if (jQuery(this).is('.emailField')) {
                email = jQuery(this).val();
            }
            if (jQuery(this).is('.emailField') && !checkEmail(jQuery(this).val())) {
                error = true;
                jQuery(this).parent().addClass('has-error');
            }
            if (jQuery(this).is('.toggle') && !jQuery(this).is('.opened')) {
            } else {
                var dbpoints = ':';
                if (jQuery('label[for="' + jQuery(this).attr('id') + '"]').html().lastIndexOf(':') == jQuery(this).attr('id').length - 1) {
                    dbpoints = '';
                }
                informations += '<p>' + jQuery('label[for="' + jQuery(this).attr('id') + '"]').html() + ' ' + dbpoints + ' <b>' + jQuery(this).val() + '</b></p>';
                fields.push({
                    label: jQuery('label[for="' + jQuery(this).attr('id') + '"]').html(),
                    value: jQuery(this).val()
                });
            }
        });


        if (!error) {

            var contentForm = getFormContent();
            var content = contentForm[0];
            var totalTxt = contentForm[1];
            var items = contentForm[2];

            jQuery.ajax({
                url: emailUrl,
                type: 'post',
                data: {
                    action: 'validateForm',
                    informations: informations,
                    email: email,
                    content: content,
                    totalTxt: totalTxt,
                    admin_email: admin_email,
                    email_subject: email_subject,
                    items: items,
                    fields: fields
                },
                success: function() {
                    finalStep();
                },
                failure: function() {
                }
            });

        }
    } else {
        var products = new Array();
        jQuery('#mainPanel .genSlide[data-title]').find('div.selectable.checked,input[type=checkbox]:checked').each(function() {
            var quantity = 1;
            if (jQuery(this).find('.icon_quantity').length > 0) {
                quantity = parseInt(jQuery(this).find('.icon_quantity').html());
            }
            products.push({
                quantity: quantity,
                product_id: parseInt(jQuery(this).data('prodid'))
            });
        });
        jQuery.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'cart_save',
                products: products
            },
            success: function() {
                finalStep();
            },
            failure: function() {
            }
        });

        console.log(products);
    }
}

function openGenerator() {
    jQuery('#btnStart').parent().fadeOut(500, function() {
        jQuery('.genPrice').fadeIn(500);
        jQuery('#mainPanel').fadeIn(500, function() {
            nextStep();
        });
    });
}

function previousStep() {
    jQuery('.errorMsg').hide();
    step--;
    changeStep();
}

function nextStep() {
    jQuery('.errorMsg').hide();
    var chkSelection = true;
    var chkSelectionitem = true;
    if (jQuery('#mainPanel .genSlide').eq(step - 1).data('required') == true) {
        chkSelection = false;
        if ((jQuery('#mainPanel .genSlide').eq(step - 1).find('div.selectable.checked').length > 0) || (jQuery('#mainPanel .genSlide').eq(step - 1).find('input[data-toggle="switch"]:checked').length > 0) || (jQuery('#mainPanel .genSlide').eq(step - 1).find('input[type=text][data-title].checked').length > 0)) {
            chkSelection = true;
        }
    }
    jQuery('#mainPanel .genSlide').eq(step - 1).find('.has-error').removeClass('has-error');
    jQuery('#mainPanel .genSlide').eq(step - 1).find('input[type=text][data-required="true"]').each(function() {
        if (jQuery(this).val().length < 1) {
            chkSelectionitem = false;
            jQuery(this).parent().addClass('has-error');
        }
    });
    jQuery('#mainPanel .genSlide').eq(step - 1).find('input[type=checkbox][data-required="true"]').each(function() {
        if (!jQuery(this).is(':checked')) {
            chkSelectionitem = false;
            jQuery(this).parent().addClass('has-error');
        }
    });
    if (chkSelection && chkSelectionitem) {
        step++;
        changeStep();
    } else if (!chkSelection) {
        jQuery('.errorMsg').slideDown();
    }

}

function changeStep() {
    jQuery('.quantityBtns').removeClass('open');
    jQuery('.quantityBtns').fadeOut(250);
    jQuery('#mainPanel .genSlide').fadeOut(1000);
    jQuery('#mainPanel .btn-next').fadeOut(500);
    jQuery('#mainPanel .linkPrevious').fadeOut(500);
    var $title = jQuery('#mainPanel .genSlide').eq(step - 1).find('h2.stepTitle');
    var $content = jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent');
    $content.find('.genContentSlide').removeClass('active');
    $content.find('.genContentSlide').eq(0).addClass('active');

    $content.animate({
        opacity: 0
    }, 500);
    $title.removeClass('positioned');
    $title.css({
        "-webkit-transition": "none",
        "transition": "none"
    });
    jQuery('#mainPanel .genSlide').eq(step - 1).delay(1000).fadeIn(1000);

    if (jQuery('#finalSlide .estimation_project').length > 0) {
        var contentForm = getFormContent();
        var content = contentForm[3];
        jQuery('#finalSlide .estimation_project textarea').val(content);
    }

    setTimeout(function() {
        $title.css({
            "-webkit-transition": "all 0.3s ease-out",
            "transition": "all 0.3s ease-out"
        }).addClass('positioned');
        $content.delay(500).animate({
            opacity: 1
        }, 500);
        jQuery('#mainPanel .btn-next').css('display', 'inline-block').hide();
        jQuery('#mainPanel .btn-next').delay(1000).fadeIn(500);
        jQuery('#mainPanel .linkPrevious').delay(1500).fadeIn(500);

        $content.delay(750).find('[data-toggle="tooltip"]').tooltip();
    }, 2200);
}

function finalStep() {
    step++;
    jQuery('#startInfos').delay(1000).fadeOut(1000);
    jQuery('#mainPanel .genSlide').fadeOut(1000);
    jQuery('#mainPanel .btn-next').fadeOut(500);
    jQuery('#mainPanel').delay(1000).fadeOut(1000);
    jQuery('.genPrice').delay(1000).fadeOut(1000);
    jQuery('#finalText').delay(2000).fadeIn(1000);

    setTimeout(function() {
        closePopup();
    }, 5500);
}

function updatePrice() {
    price = initialPrice;
    jQuery('#mainPanel .genSlide div.selectable.checked , input[type=checkbox]:checked').each(function() {
        if (jQuery(this).data('price')) {
            if (jQuery(this).find('.icon_quantity').length > 0) {
                price += parseFloat(jQuery(this).data('price')) * parseInt(jQuery(this).find('.icon_quantity').html());
            } else {
                price += jQuery(this).data('price');
            }
        }
    });
    if (price < 0) {
        price = 0;
    }
    jQuery('.genPrice .progress .progress-bar-price').html(price + ' ' + currency);
    var percent = (price * 100) / priceMax;
    jQuery('.genPrice .progress .progress-bar').css('width', percent + '%');
    jQuery('.genPrice .progress .progress-bar-price').animate({
        left: percent + '%'
    }, 70);
    jQuery('#finalPrice').html(price + ' ' + currency);
}

function changeContentSlide(dir) {
    var index = jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide.active').index();
    if (dir == 'left') {
        if (index > 0) {
            index--;
        } else {
            index = jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide').length;
        }
    } else {
        if (index < jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide').length - 1) {
            index++;
        } else {
            index = 0;
        }
    }
    jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide.active').fadeOut(500, function() {
        jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide.active').removeClass('active');
        jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide').eq(index).delay(200).fadeIn(500, function() {
            jQuery('#mainPanel .genSlide').eq(step - 1).find('.genContent').find('.genContentSlide').eq(index).delay(250).addClass('active');
        });
    });
}

function toggleField(fieldID) {
    if (jQuery('#field_' + fieldID + '_cb').is(':checked')) {
        jQuery('#field_' + fieldID).addClass('opened');
        jQuery('#field_' + fieldID).slideDown(250);
    } else {
        jQuery('#field_' + fieldID).removeClass('opened');
        jQuery('#field_' + fieldID).slideUp(250);
    }
}
